require 'net/http'
require 'json'

module BuBus
  class Client
            
    def initialize()
    end

    def buses(&block)
      buses = request(BuBus::Bus::URL)["ResultSet"]["Result"]
      buses = buses.map {|bus| Bus.new(bus) }
      
      return buses unless block_given?
      buses.map {|bus| block.call(bus)} 
    end 

    def stops(&block)
      stops = request(BuBus::Stop::URL)["ResultSet"]["Result"]
      stops = stops.map {|stop| Stop.new(stop)}

      return stops unless block_given?
      stops.map {|stop| block.call(stop)}
    end
  
   private 
    def request(url)
      res = Net::HTTP.get_response(URI(url))
      if(res.is_a?(Net::HTTPOK))
        res = JSON.parse(res.body)
      else
        raise 'Error server responded with: #{res.code}'
      end
    end
  end
end
